unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    panel0: TPanel;
    Panel1: TPanel;
    Shape1: TShape;
    BitBtn1: TBitBtn;
    Button1: TButton;
    Label1: TLabel;
    rg1: TRadioGroup;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure rg1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setmode(index:integer;ctl:twincontrol);
    procedure mymouseMove(sender:tobject;Shift: TShiftState; X, Y: Integer);
    procedure myMouseDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure myMouseUp(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);

  end;

var
  Form1: TForm1;
  xx,yy:integer;


implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
    setmode(rg1.ItemIndex,panel0);
end;

procedure TForm1.mymouseMove(sender:tobject;Shift: TShiftState; X, Y: Integer);
var ct:tcontrol;
begin
       ct:=getcapturecontrol;
       if ct =nil then exit;
       ct.left:=ct.left+x-xx;
       ct.top:=ct.top+y-yy;
end;

procedure TForm1.myMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ctl:tcontrol;
begin
     ctl:=tcontrol(sender);
     setcapturecontrol(ctl);
     xx:=x;
     yy:=y;
end;

procedure TForm1.myMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
      releasecapture;
end;

procedure TForm1.setmode(index: integer; ctl: twincontrol);
var i:integer;
begin
    case index of

    0:
      begin
        for i:=0 to ctl.Controlcount -1 do begin
              tpanel(ctl.Controls[i]).OnMouseMove:=nil;
              tpanel(ctl.Controls[i]).OnMousedown:=nil;
              tpanel(ctl.Controls[i]).OnMouseup:=nil;
        end;
      end;
    1:
      begin
        for i:=0 to ctl.Controlcount -1 do begin
            if ctl.Controls[i].Parent = ctl then begin
              tpanel(ctl.Controls[i]).OnMouseMove:=mymousemove;
              tpanel(ctl.Controls[i]).OnMousedown:=mymousedown;
              tpanel(ctl.Controls[i]).OnMouseup:=mymouseup;
            end;
        end;
      end;
    end;
end;

procedure TForm1.rg1Click(Sender: TObject);
begin
     setmode(rg1.ItemIndex,panel0);
end;

end.
